<div class="panel woocommerce_options_panel">
	<?php if ( is_array( $distri_order ) ) : ?>
        <div class="options_group">
            <p class="form-field ">
                <label>Order ID</label>
                <span><?php echo $distri_order['dm_order_id'] ?></span>
            </p>
			<?php if ( isset( $distri_order['dm_status'] ) ) :
				$status = json_decode( $distri_order['dm_status'] );
				?>
                <p class="form-field ">
                    <label>Status</label>
                    <span><?php

                        if(isset($status->OrderStatus)) {
                            echo is_array($status->OrderStatus) ? $status->OrderStatus[0] : $status->OrderStatus;
                        } else {
                            echo __('Unknown', 'distrimedia-integration');
                        }
                        ?></span>
                </p>

               <?php echo $this->getTrackingUrl($status) ?>
			<?php endif ?>
        </div>

	<?php else : ?>
        <p>No Distrimedia Details Available</p>
        <p>
			<?php
			$parts = parse_url( home_url() );
			$current_uri = "{$parts['scheme']}://{$parts['host']}" . add_query_arg( NULL, NULL );
			$queryStr = '?dm-order-id=' . $order->get_id();
			$queryStr .= '&dm-redirect=' . urlencode($current_uri);
            $newurl = add_query_arg( array(
                'dm-order-id' => $order->get_id(),
                'dm-redirect' => urlencode(wc_get_current_admin_url()),
            ), wc_get_current_admin_url() );
			?>
            <!-- <a class="button save_order button-primary" href="<?php echo site_url($queryStr) ?>"><?php echo __('Create Order') ?></a> -->
            <a class="button save_order button-primary" href="<?php echo esc_url($newurl); ?>"><?php echo __('Create Order') ?></a>
        </p>
	<?php endif ?>

	<?php if ( $orderLogs && is_array( $orderLogs ) ) : ?>
        <div class="options_group">
            <ul class="order_notes">
				<?php foreach ( $orderLogs as $logEntry ) :
					$errorClass = ( $logEntry->log_type == 3 || $logEntry->log_type == 9 ) ? ' system-note' : '';
					?>
                    <li rel="110" class="note<?php echo $errorClass ?>">
                        <div class="note_content">
                            <p><?php
								if ( isset( $logEntry->message ) && $logEntry->message ) {
									$messageData = json_decode( $logEntry->message );
									$msg         = '';

									if ( isset( $messageData->Reason ) ) {
										$msg .= $messageData->Reason;
									}

									echo $msg ? $msg : __( 'Not able to process distrimedia call', 'distrimedia-integration' );
								}

								?></p>
                        </div>
                        <p class="meta">
                            <abbr class="exact-date">
								<?php
								$created_at = new DateTime( $logEntry->created_at );
								/* translators: $1: Date created, $2 Time created */
								printf( esc_html__( 'added on %1$s at %2$s', 'woocommerce' ), esc_html( $created_at->format( wc_date_format() ) ), esc_html( $created_at->format( wc_time_format() ) ) );
								?>
                            </abbr>
                        </p>
                    </li>
				<?php endforeach; ?>
            </ul>
        </div>
	<?php endif ?>
</div>