jQuery(document).ready(function ($) {

    checkoutChange();

    //When Shipping Method Changes
    // $('body').on('update_checkout', function (e) {
        // checkoutChange();
    // });

    $(document).on('change', '.woocommerce  #shipping_method .shipping_method', function() {
        checkoutChange();
    });

    //Toggle Map
    $('.bpost-showmap').on('click', function () {
        $(this).hide();
        $('#bpostmap').show();
        $('.bpost-hidemap').show();
    });

    $('.bpost-hidemap').on('click', function () {
        $(this).hide();
        $('#bpostmap').hide();
        $('.bpost-showmap').show();
    });

    //Show Post office timings
    $('.bpost-point-tiles').on('click', '.b-toggle-timing', function () {
        if ($(this).hasClass('b-timing-close')) {
            $(this).removeClass('b-timing-close')
                .addClass('b-timing-open');

            $(this).siblings('.b-tile-times').show();
        } else {
            $(this).addClass('b-timing-close')
                .removeClass('b-timing-open');

            $(this).siblings('.b-tile-times').hide();
        }
    });

    //Select Point
    $('.bpost-point-tiles').on('click', '.bpost-tile', function () {
        $(this).addClass('bpost-active').siblings().removeClass('bpost-active');
        $(this).addClass(distrimedia_data.bpostBackgroundColor).siblings().removeClass(distrimedia_data.bpostBackgroundColor);

        $('#bpost_point').val($(this).data('id'));
    })

    function checkoutChange() {
        shippingMethod = $(".shipping_method:checked").val();

        //If we have only 1 shipping method
        if(typeof shippingMethod == 'undefined') {
            shippingMethod = $('#shipping_method input').val();
        }

        if (shippingMethod.includes('distrimedia_locker') || shippingMethod.includes('distrimedia_pickup')) {
            //Disable Shipping Checkbox
            $('#ship-to-different-address-checkbox').prop('checked', false);

            $('.woocommerce-shipping-fields').hide();
            //Clean first
            resetSearches();
            onPlaceChanged();
            $('.bpost-point').show();
        } else {
            $('.woocommerce-shipping-fields').show();
            $('.bpost-point').hide();
        }
    }
});

var bpostMap, bpostPlaces, infoWindow, shippingMethod;
var bpostMarkers = [];
var bpostAutocomplete;
var markerCluster = false;
var bpostStyle = [
    {
        featureType: "road",
        elementType: "geometry",
        stylers: [
            {lightness: 100},
            {visibility: "simplified"}
        ]
    },
    {
        featureType: "transit",
        elementType: "labels",
        stylers: [
            {visibility: "off"}
        ]
    },
    {
        featureType: 'poi',
        stylers: [
            {visibility: "off"}
        ]
    },
    {
        featureType: 'poi.business',
        stylers: [{visibility: 'off'}]
    },
    {
        featureType: 'transit',
        elementType: 'labels.icon',
        stylers: [{visibility: 'off'}]
    }

];

function initBpostMap() {
    bpostMap = new google.maps.Map(document.getElementById('bpostmap'), {
        center: {lat: 50.503887, lng: 4.469936},
        zoom: 8,
        mapTypeControl: true,
        // panControl: false,
        // zoomControl: false,
        streetViewControl: true,
        styles: bpostStyle
    });

    // Create the autocomplete object and associate it with the UI input control.
    // Restrict the search to the default country, and to place type "cities".
    bpostAutocomplete = new google.maps.places.Autocomplete(
        /** @type {!HTMLInputElement} */ (
            document.getElementById('bpost-autocomplete')), {
            types: [],
            componentRestrictions: {'country': 'be'}
        });
    bpostPlaces = new google.maps.places.PlacesService(bpostMap);

    bpostAutocomplete.addListener('place_changed', onPlaceChanged);

    // Add a DOM event listener to react when the user selects a country.
    // document.getElementById('country').addEventListener(
    //     'change', setAutocompleteCountry);

}

function onPlaceChanged() {
    let place = bpostAutocomplete.getPlace();
    //Clean first
    resetSearches();

    if (typeof place !== 'undefined' && place.geometry) {
        bpostMap.panTo(place.geometry.location);
        bpostMap.setZoom(parseInt(distrimedia_data.bpostZoom));
        searchLocations(place);
    } else {
        document.getElementById('bpost-autocomplete').placeholder = 'Enter a city';
    }
}

function resetSearches() {
    jQuery('#bpost_point').val('');
    jQuery('.bpost-point-lists').html('');

    if (markerCluster) {
        markerCluster.clearMarkers();
    }

    markerCluster = false;
}

function searchLocations(place) {
    let locations = distrimedia_data.bpostPoints,
        targetPoint = {};

    let locationFilt = locations.map(function (location, i) {
        targetPoint.lat = location.Latitude;
        targetPoint.lng = location.Longitude;
        // console.log(arePointsNear(targetPoint, place.geometry.location, 500));
        // console.log(location.Latitude, location.Longitude, place.geometry.location.lat(), place.geometry.location.lng());
        location.Distance = pointDistance(location.Latitude, location.Longitude, place.geometry.location.lat(), place.geometry.location.lng(), 'K');
        return location;
    });

    //Put closest First
    locationFilt.sort(function(a, b) {
        return parseFloat(a.Distance) - parseFloat(b.Distance);
    });

    let point, markers = [], counter = 0, smallDist = 0, moreDist = 0;

    for (let i = 0; i < locationFilt.length; i++) {
        if (locationFilt[i].Distance < distrimedia_data.bpostRadius) {
            point = locationFilt[i];

            if(shippingMethod.includes('distrimedia_locker') && point.Type != 4) {
                continue;
            }

            if(shippingMethod.includes('distrimedia_pickup') && point.Type == 4) {
                continue;
            }

            if(counter == distrimedia_data.bpostResult) {
                break;
            }

            counter++;
            jQuery('.bpost-point-lists').append(renderPoint(point));

            markers.push(addMarkers(point, i));
        }
    }

    // Add a marker clusterer to manage the markers.
    markerCluster = new MarkerClusterer(bpostMap, markers,
        {
            maxZoom: 10,
            imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m'
        });
}

function addMarkers(point, i) {
    let marker;
    marker = new google.maps.Marker({
        position: new google.maps.LatLng(point.Latitude, point.Longitude),
        title: point.Name
    });

    let pointHtml = '<div class="bpost-infobox"><div class="b-tile-title">' + point.Name + '</div>\n' +
        '<span class="b-tile-addr">' + renderAddress(point) + '</span>' +
        '<a class="bpost-map-more btn btn-sm" target="_blank" href="http://pudo.bpost.be/Locator?Function=page&Partner=001880&Language=NL&Id=' + point.Id + '&Type=' + point.Type + '&Country=BE">More Info</a>' +
        '\n</div>';

    let infowindow = new google.maps.InfoWindow({
        content: pointHtml
    });


    google.maps.event.addListener(marker, 'click', (function (marker, i) {
        return function () {
            // infowindow.open(bpostMap, marker);

            jQuery("#bpost_point").val(point.Id);
            jQuery('.bpost-id-' + point.Id).click();
        }
    })(marker, i));

    return marker;
}

function pointDistance(lat1, lon1, lat2, lon2, unit) {
    if ((lat1 == lat2) && (lon1 == lon2)) {
        return 0;
    } else {
        var radlat1 = Math.PI * lat1 / 180;
        var radlat2 = Math.PI * lat2 / 180;
        var theta = lon1 - lon2;
        var radtheta = Math.PI * theta / 180;
        var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
        if (dist > 1) {
            dist = 1;
        }
        dist = Math.acos(dist);
        dist = dist * 180 / Math.PI;
        dist = dist * 60 * 1.1515;
        if (unit == "K") {
            dist = dist * 1.609344
        }
        if (unit == "N") {
            dist = dist * 0.8684
        }
        return dist;
    }
}

function renderPoint(point) {
    let htmlStr = '<li class="bpost-tile bpost-id-' + point.Id + '" data-id="' + point.Id + '">\n' +
        '<span class="b-tile-title">' + point.Name + '</span>\n' +
        '<span class="b-tile-addr">' + renderAddress(point) + '</span>\n' +
        '<span class="b-toggle-timing b-timing-close"><span class="dashicons dashicons-clock"></span> View opening hours</span>\n' +
        '<span class="b-tile-times" style="display: none">\n' +
        renderTimings(point) +
        '</span>\n' +
        '</li>';


    return htmlStr;
}

function renderAddress(point) {
    let htmlStr = '';

    if (point.Number) htmlStr += point.Number + ' ';
    if (point.Street) htmlStr += point.Street + ' ';
    if (point.Zip) htmlStr += point.Zip + ' ';
    if (point.City) htmlStr += point.City + ' ';

    return htmlStr;
}

function renderTimings(point) {
    let timings = point.Hours;
    let htmlStr = "<ul>\n";

    let days = ['Friday', 'Saturday', 'Sunday', 'Monday', "Tuesday", "Wednesday", "Thursday"];
    for (let i = 0; i < days.length; i++) {

        if(typeof timings[days[i]].AMOpen == 'object' && typeof timings[days[i]].PMOpen == 'object') {
            continue;
        }

        htmlStr += '<li class="bpost-day"><span>' + days[i] + '</span>\n' +
            '<ul>\n';

        if(typeof timings[days[i]].AMOpen !== 'object') {
            htmlStr += '<li>' + timings[days[i]].AMOpen + ' - ' + timings[days[i]].AMClose + '</li>\n';
        }

        if(typeof timings[days[i]].PMOpen !== 'object') {
            htmlStr += '<li>' + timings[days[i]].PMOpen + ' - ' + timings[days[i]].PMClose + '</li>\n';
        }

        htmlStr += '</ul>\n' +
            '</li>';
    }

    htmlStr += '<li class="bpost-url"><a target="_blank" href="http://pudo.bpost.be/Locator?Function=page&Partner=001880&Language=NL&Id=' + point.Id + '&Type=' + point.Type + '&Country=BE"><span class="dashicons dashicons-admin-links"></span> More Info</a></li>';

    htmlStr += "</ul>\n";
    // timings.forEach(function(time, dayName) {
    //     console.log(dayName, time);
    // });
    // "<li>Monday\n" +
    // "<ul>\n" +
    // "<li>09:30 - 12:30</li>\n" +
    // "<li>13:30 - 18:00</li>\n" +
    // "</ul>\n" +
    // "</li>\n" +
    // "<li>Monday\n" +
    // "<ul>\n" +
    // "<li>09:30 - 12:30</li>\n" +
    // "<li>13:30 - 18:00</li>\n" +
    // "</ul>\n" +
    // "</li>\n" +
    // "<li>Monday\n" +
    // "<ul>\n" +
    // "<li>09:30 - 12:30</li>\n" +
    // "<li>13:30 - 18:00</li>\n" +
    // "</ul>\n" +
    // "</li>\n" +
    // "</ul>"

    return htmlStr;
}

// function arePointsNear(checkPoint, centerPoint, km) {
//     var ky = 40000 / 360;
//     var kx = Math.cos(Math.PI * centerPoint.lat / 180.0) * ky;
//     var dx = Math.abs(centerPoint.lng - checkPoint.lng) * kx;
//     var dy = Math.abs(centerPoint.lat - checkPoint.lat) * ky;
//     return Math.sqrt(dx * dx + dy * dy) <= km;
// }
